// 0 = chat_tag | 1 = chat_tag_color | 2 = chat_nick_color | 3 = chat_text_color
static iAction[MAXPLAYERS + 1];

stock wS_MainMenu(client)
{
	new Handle:menu = CreateMenu(MainMenu_CallBack);
	SetMenuTitle(menu, "%T\n \n", "title", client);
	SetMenuExitBackButton(menu, true);

	decl String:sText[64], String:sColorName[COLOR_NAME_LENGTH];

	// тег
	FormatEx(sText, sizeof(sText), "%T",		"chat_tag",			client, g_sMyTag[client][0] != 0x01 ? g_sMyTag[client] : "-");
	AddMenuItem(menu, "3", sText, g_bForce[client][eF_tag]			? ITEMDRAW_DISABLED : ITEMDRAW_DEFAULT);

	// цвет тега
	wS_GetColorName(client, 0, sColorName,		COLOR_NAME_LENGTH);
	FormatEx(sText, sizeof(sText), "%T",		"chat_tag_color",	client, sColorName);
	AddMenuItem(menu, "0", sText, g_bForce[client][eF_tag_color]	? ITEMDRAW_DISABLED : ITEMDRAW_DEFAULT);

	// цвет ника
	wS_GetColorName(client, 1, sColorName,		COLOR_NAME_LENGTH);
	FormatEx(sText, sizeof(sText), "%T",		"chat_nick_color",	client, sColorName);
	AddMenuItem(menu, "1", sText, g_bForce[client][eF_nick_color]	? ITEMDRAW_DISABLED : ITEMDRAW_DEFAULT);

	// цвет сообщения
	wS_GetColorName(client, 2, sColorName,		COLOR_NAME_LENGTH);
	FormatEx(sText, sizeof(sText), "%T\n \n",	"chat_text_color",	client, sColorName);
	AddMenuItem(menu, "2", sText, g_bForce[client][eF_msg_color]	? ITEMDRAW_DISABLED : ITEMDRAW_DEFAULT);
	
	// вкл/откл
	FormatEx(sText, sizeof(sText), "%T", g_bEnabled[client] ? "disable" : "enable", client);
	AddMenuItem(menu, "x", sText, ITEMDRAW_DEFAULT);

	DisplayMenu(menu, client, 0);
}

static wS_GetColorName(client, i, String:buffer[], maxlength)
{
	if (g_iMyColorIndex[client][i] != INVALID_INDEX) GetArrayString(g_hColorNameAr, g_iMyColorIndex[client][i], buffer, maxlength);
	else strcopy(buffer, maxlength, "-");
}

public MainMenu_CallBack(Handle:menu, MenuAction:action, client, item)
{
	if (action == MenuAction_End)
		CloseHandle(menu);

	else if (action == MenuAction_Cancel && item == MenuCancel_ExitBack && !VIP_MenuFlood(client))
		VIP_ShowMenu(client);

	else if (action == MenuAction_Select && !VIP_MenuFlood(client))
	{
		new bool:bAccessByFlag;
		if (!VIP_HaveAccessToItem(client, g_ItemID, bAccessByFlag))
		{
			VIP_ShowMenu(client);
			return;
		}
		
		decl String:info[4];
		if (!GetMenuItem(menu, item, info, sizeof(info)))
			return;
		
		if (!strcmp(info, "x", false)) // toggle
		{
			g_bEnabled[client] = !g_bEnabled[client];
			TryUpdateKeyValue(client, "chat_off", g_bEnabled[client] ? "" : "1", bAccessByFlag);
			if (g_bReady[client]) VIP_NotifyItemStatusChanged(client, ITEM_NAME, g_bEnabled[client]);
			wS_MainMenu(client);
		}
		else if ((iAction[client] = StringToInt(info)) == 3) wS_TagMenu(client);
		else wS_ColorMenu(client);
	}
}

/////

static wS_TagMenu(client, item = 0)
{
	decl String:group[GROUP_LENGTH];
	if (!VIP_GetGroupName(client, group, GROUP_LENGTH))
		group[0] = 0;

	new Handle:menu = CreateMenu(TagMenu_CallBack);
	SetMenuTitle(menu, "%T\n \n", "chat_tag", client, "");
	SetMenuExitBackButton(menu, true);

	decl String:sTag[TAG_LENGTH], Handle:hTrie, String:sIndex[12];

	FormatEx(sTag, TAG_LENGTH, "%T", "disable", client);
	AddMenuItem(menu, "disable", sTag, g_sMyTag[client][0] != 0x01 ? ITEMDRAW_DEFAULT : ITEMDRAW_DISABLED);

	for (new i = 0; i < g_iTagCount; i++)
	{
		if (!(hTrie = Handle:GetArrayCell(g_hTagVipGroupAr, i)) || (group[0] && GetTrieValue(hTrie, group, hTrie)))
		{
			if (i != g_iMyTagIndex[client])
			{
				IntToString(i, sIndex, sizeof(sIndex));
				GetArrayString(g_hTagAr, i, sTag, TAG_LENGTH);
				AddMenuItem(menu, sIndex, sTag, ITEMDRAW_DEFAULT);
			}
			else
				AddMenuItem(menu, "", g_sMyTag[client], ITEMDRAW_DISABLED);
		}
	}

	DisplayMenuAtItem(menu, client, item, 0);
}

public TagMenu_CallBack(Handle:menu, MenuAction:action, client, item)
{
	if (action == MenuAction_End)
		CloseHandle(menu);

	else if (action == MenuAction_Cancel && item == MenuCancel_ExitBack && !VIP_MenuFlood(client))
		wS_MainMenu(client);

	else if (action == MenuAction_Select && !VIP_MenuFlood(client))
	{
		new bool:bAccessByFlag;
		if (!VIP_HaveAccessToItem(client, g_ItemID, bAccessByFlag))
		{
			VIP_ShowMenu(client);
			return;
		}
		
		decl String:sIndex[12];
		if (!GetMenuItem(menu, item, sIndex, sizeof(sIndex)))
			return;

		decl String:sTagKey[TAG_LENGTH];

		if (strcmp(sIndex, "disable", false) == 0)
		{
			g_iMyTagIndex[client]			= INVALID_INDEX;
			g_sMyTag[client][0]				= 0x01;
			g_sMyTag[client][1]				= 0;
			sTagKey[0]						= 0;

			g_iMyColorIndex[client][0]		= INVALID_INDEX;
			g_sMyColorString[client][0][0]	= 0x01;
			g_sMyColorString[client][0][1]	= 0;
		}
		else
		{
			g_iMyTagIndex[client]			= StringToInt(sIndex);
			GetArrayString(g_hTagKeyAr,		g_iMyTagIndex[client], sTagKey, sizeof(sTagKey));
			GetArrayString(g_hTagAr,		g_iMyTagIndex[client], g_sMyTag[client], TAG_LENGTH);
		}

		TryUpdateKeyValue(client, "chat_tag", sTagKey, bAccessByFlag);
		
		wS_Ready(client);
		wS_TagMenu(client, GetMenuSelectionPosition());
	}
}

/////

static wS_ColorMenu(client, item = 0)
{
	decl String:group[GROUP_LENGTH];
	if (!VIP_GetGroupName(client, group, GROUP_LENGTH))
		group[0] = 0;

	new Handle:menu = CreateMenu(ColorMenu_CallBack);
	SetMenuTitle(menu, "%T\n \n", (iAction[client] == 0 ? "chat_tag_color" : (iAction[client] == 1 ? "chat_nick_color" : "chat_text_color")), client, "");
	SetMenuExitBackButton(menu, true);

	decl String:sIndex[8], String:sColorString[sizeof(g_sMyColorString[][])], Handle:hTrie, ItemType;

	decl String:sColorName[COLOR_NAME_LENGTH];
	FormatEx(sColorName, COLOR_NAME_LENGTH, "%T", "disable", client);
	AddMenuItem(menu, "", sColorName, g_sMyColorString[client][iAction[client]][0] != 0x01 ? ITEMDRAW_DEFAULT : ITEMDRAW_DISABLED);

	for (new i = 0; i < g_iColorCount; i++)
	{
		if (!(hTrie = Handle:GetArrayCell(g_hColorVipGroupAr, i)) || (group[0] && GetTrieValue(hTrie, group, hTrie)))
		{
			IntToString(i, sIndex, sizeof(sIndex));
			GetArrayString(g_hColorNameAr, i, sColorName, COLOR_NAME_LENGTH);

			if (i != g_iMyColorIndex[client][iAction[client]])
			{
				ItemType = ITEMDRAW_DEFAULT;
				
				if (g_bTeamColorUse[client] && g_ServerType != 1)
				{
					GetArrayString(g_hColorStringAr, i, sColorString, sizeof(sColorString));
					if (!strcmp(sColorString, "\x03", false)) // team color with lightgreen not work in css
						ItemType = ITEMDRAW_DISABLED;
				}
			}
			else
				ItemType = ITEMDRAW_DISABLED;

			AddMenuItem(menu, sIndex, sColorName, ItemType);
		}
	}

	DisplayMenuAtItem(menu, client, item, 0);
}

public ColorMenu_CallBack(Handle:menu, MenuAction:action, client, item)
{
	if (action == MenuAction_End)
		CloseHandle(menu);

	else if (action == MenuAction_Cancel && item == MenuCancel_ExitBack && !VIP_MenuFlood(client))
		wS_MainMenu(client);

	else if (action == MenuAction_Select && !VIP_MenuFlood(client))
	{
		new bool:bAccessByFlag;
		if (!VIP_HaveAccessToItem(client, g_ItemID, bAccessByFlag))
		{
			VIP_ShowMenu(client);
			return;
		}
		
		decl String:sIndex[8];
		if (!GetMenuItem(menu, item, sIndex, sizeof(sIndex)))
			return;

		if (!sIndex[0])
		{
			g_iMyColorIndex [client][iAction[client]]		= INVALID_INDEX;
			g_sMyColorString[client][iAction[client]][0]	= 0x01;
			g_sMyColorString[client][iAction[client]][1]	= 0;
		}
		else
		{
			g_iMyColorIndex[client][iAction[client]]		= StringToInt(sIndex);
			GetArrayString(g_hColorStringAr, g_iMyColorIndex[client][iAction[client]], g_sMyColorString[client][iAction[client]], sizeof(g_sMyColorString[][]));
		}

		if (bAccessByFlag || VIP_GetFlags(client) & VCF_VIP)
		{
			new Handle:kv = VIP_GetClientCache(client);
			if (kv)
			{
				new String:s[][] = {"chat_tag_color", "chat_nick_color", "chat_text_color"};

				if (g_iMyColorIndex[client][iAction[client]] != INVALID_INDEX)
				{
					decl String:sColorNameKey[COLOR_NAME_LENGTH];
					GetArrayString(g_hColorNameKeyAr, g_iMyColorIndex[client][iAction[client]], sColorNameKey, COLOR_NAME_LENGTH);
					KvSetString(kv, s[iAction[client]], sColorNameKey);
				}
				else
					KvSetString(kv, s[iAction[client]], "");
				
				VIP_SaveClientCache(client, false);
			}
		}
		
		wS_Ready(client);
		wS_ColorMenu(client, GetMenuSelectionPosition());
	}
}